#include <windows.h>
#include "dmcdlg.h"
#include <string.h>
#include <string>
#include <sstream>

template <typename T>
std::string ToString(T aValue)
{
   std::stringstream ss;
   ss << aValue;
   return ss.str();
}

BOOL CALLBACK DialogFunc(HWND aDlg, UINT aMsg, WPARAM wParam, LPARAM lParam)
{
   switch(aMsg)
   {
   case WM_INITDIALOG:
      {
         RECT R;
         GetWindowRect(aDlg, &R);
         std::stringstream SS1;
         SS1 << "Left: " << R.left << " Top: " << R.top << " Right: " << R.right << " Bottom: " << R.bottom;
         SetDlgItemText(aDlg, IDC_EDIT_1, SS1.str().c_str());
         R.left = 100;
         R.top = 100;
         R.right = 300;
         R.bottom = 180;
         MapDialogRect(aDlg, &R);
         std::stringstream SS;
         SS << "Left: " << R.left << " Top: " << R.top << " Right: " << R.right << " Bottom: " << R.bottom;
         SetDlgItemText(aDlg, IDC_EDIT_2, SS.str().c_str());
      }
      return TRUE;
   case WM_CLOSE:
      EndDialog(aDlg, 0);
      return TRUE;
   }
   return FALSE;
}

int APIENTRY WinMain(HINSTANCE aHinst, HINSTANCE aHinstPrev, LPSTR aCmdLine, int aCmdShow)
{
   WNDCLASS wc;

   memset(&wc, 0, sizeof(wc));
   wc.lpfnWndProc = DefDlgProc;
   wc.cbWndExtra = DLGWINDOWEXTRA;
   wc.hInstance = aHinst;
   wc.hCursor = LoadCursor(0, IDC_ARROW);
   wc.hbrBackground = (HBRUSH )(COLOR_WINDOW + 1);
   wc.lpszClassName = "dmcdlg";
   RegisterClass(&wc);

   return DialogBox(aHinst, MAKEINTRESOURCE(IDD_MAINDIALOG), 0, (DLGPROC )DialogFunc);
}

